include \masm32\include\masm32rt.inc
.686
include timers.asm

.data
ALIGN 16
   na      dd  3239879239, 1309340349, 2349087349, 4020030040
          dd   239879239, 2023987439, 1234567890,   23978239
          dd  1245409999, 3340340309,  343498392, 3020030040

   nb      dd  1340983534, 3295798324, 3843298739, 1897349923
          dd  2398721309, 1347204809, 4085034850, 2409872134
          dd  2594597492, 2398792379, 1398349830, 4139823991

   nc      dd  3239879239, 1309340349, 2349087349, 4020030040
          dd   239879239, 2023987439, 1234567890,   23978239
          dd  1245409999, 3340340309,  343498392, 3020030040

   nd      dd  1340983534, 3295798324, 3843298739, 1897349923
          dd  2398721309, 1347204809, 4085034850, 2409872134
          dd  2594597492, 2398792379, 1398349830, 4139823991

   e      dd  12 dup (0)  ;  384 bit unsigned values

   f      dd  12 dup (0)

.code
start:

	mov eax, na
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	
	clc
	mov eax, [nc +  0]
	mov ebx, [nc +  4]
	mov ecx, [nc +  8]
	mov edx, [nc + 12]
	
	adc [nd +  0], eax
	adc [nd +  4], ebx
	adc [nd +  8], ecx
	adc [nd + 12], edx
	
	mov eax, [nc + 16]
	mov ebx, [nc + 20]
	mov ecx, [nc + 24]
	mov edx, [nc + 28]
	
	adc [nd + 16], eax
	adc [nd + 20], ebx
	adc [nd + 24], ecx
	adc [nd + 28], edx
	
	mov eax, [nc + 32]
	mov ebx, [nc + 36]
	mov ecx, [nc + 40]
	mov edx, [nc + 44]
	
	adc [nd + 32], eax
	adc [nd + 36], ebx
	adc [nd + 40], ecx
	adc [nd + 44], edx
	
	counter_end
	print ustr$(eax)
	print " cycles, original ALU code", 13,10
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	
	xor  ecx, ecx
	lea  esi, nc
	lea  edi, nd
	clc
@@:
	mov  eax, [esi + ecx*4]
	adc  [edi + ecx*4], eax
	inc  ecx
	cmp  ecx, 12
	jne  @B
	
	counter_end
	print ustr$(eax)
	print " cycles, asmfan's code", 13, 10
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	
	xor ecx, ecx
	lea esi, nc
	lea edi, nd
	clc
@@:
	mov eax, [esi + ecx*8]
	mov	ebx, [esi + ecx*8+4]
	adc [edi + ecx*8], eax
	adc [edi + ecx*8+4], ebx
	inc ecx
	cmp ecx, 6
	jne @B
	
	counter_end
	print ustr$(eax)
	print " cycles, unrolled by 2", 13, 10
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	
	xor ecx, ecx
	lea esi, nc
	lea edi, nd
	clc
@@:
	mov eax, [esi + ecx*8]
	mov	ebx, [esi + ecx*8+4]
	adc [edi + ecx*8], eax
	adc [edi + ecx*8+4], ebx
	
	mov eax, [esi + ecx*8+8]
	mov ebx, [esi + ecx*8+12]
	adc [edi + ecx*8+8], eax
	adc [edi + ecx*8+12], ebx
	
	inc ecx
	inc ecx
	cmp ecx, 6
	jne @B
	
	counter_end
	print ustr$(eax)
	print " cycles, unrolled by 4", 13, 10
	
	inkey "Press any key to exit...",13,10
	exit

end start